#! /usr/bin/env python
import MySQLdb, optparse, string, csv
import mdbase

##############################################################################
# Main program

# Parse command line options
parser = optparse.OptionParser(usage="usage: %prog [options] securities")
#parser.add_option("-d", "--date", action="store_true", dest="fromDate", help="initial quote date")
(options, args) = parser.parse_args()

if len(args) == 0:
    parser.error("no securities specified")

db = mdbase.get_db_connection()
for security in args:
    # Select security quotes
    query = "SELECT s.ticker, REPLACE(q.date, '-', ''), q.open, q.high, q.low, q.close, q.volume, q.adjustedClose \
    FROM Securities s, Quotes q \
    WHERE s.idSecurity = q.idSecurity \
    AND s.ticker = '" + security + "'"

    cursor = db.cursor()
    cursor.execute(query)
    data = cursor.fetchall()
    cursor.close()

    # Write csv file with quotes
    header=["ticker","date","open","high","low","close","volume","adjclose"]
    file = string.strip(security, "^") + ".csv"
    csvwriter = csv.writer(open(file, "w"))
    csvwriter.writerow(header)
    csvwriter.writerows(data)

db.close()
