import urllib, urllib2, datetime, string

def get_historical_quotes(ticker, fromDate, toDate):
    """Download historical quotes from Yahoo Finance"""

    # Create dictionary with url options 
    quote = dict()
    quote['s'] = ticker
    quote['g'] = "d" 
    if not toDate is None:
        quote['d'] = str(toDate.month -1)
        quote['e'] = str(toDate.day)
        quote['f'] = str(toDate.year)
    if not fromDate is None:
        quote['a'] = str(fromDate.month - 1)
        quote['b'] = str(fromDate.day)
        quote['c'] = str(fromDate.year)

    # Construct url and fetch result
    params = urllib.urlencode(quote) + "&ignore=.csv"
    url = "http://ichart.finance.yahoo.com/table.csv?" + params

    try:
        response = urllib2.urlopen(url)
        csvResponse = response.read()
    except urllib2.HTTPError:
        print "Error downloading quotes for " + ticker + ". Url: " + url
        return None 

    # Split result and create list of securities
    lines = csvResponse.split("\n")
    del(lines[0])
    data = []
    for line in lines:
        if line != "": data.append(line.split(","))

    return data

def getCurrentQuotes(tickers):
    """Download current quotes from Yahoo Finance.
    Returns a list with an element for each ticker.
    Each element contains a list with:
    symbol, name, last trade, change, percent change, volume, last trade date."""
        
    options = "snl1c1p2vd1"
    url = "http://finance.yahoo.com/d/quotes.csv?s=" + string.join(tickers, "+") + "&f=" + options

    response = urllib2.urlopen(url)
    csvResponse = response.read()
    csvResponse = csvResponse.replace("\"","")
    
    # Split result and create list of securities
    lines = csvResponse.split("\n")
    data = []
    for line in lines:
        if line != "": data.append(line.split(","))
    
    return data
